#include <pspkernel.h>
#include <stdio.h>
#include <stdarg.h>
#include <string.h>
#include "pg.h"
#include "dialog.h"

extern int bQuit;

extern u16 _menubmp[];
extern u16 _splashbmp[];
u16 *bBitmap = _menubmp;

void dlg_frame(const char *msg0, const char *msg1)
{
  int x;
    
  if(bBitmap)
    pgBitBlt(0,0,480,272,1,bBitmap);
  else
    pgFillvram(BLACK);
  // CACbCZA[CWBHBG
  if(msg0) mh_print(17, 0, msg0, WHITE);
  pgDrawFrame(17,25,463,248,GREY);
  pgDrawFrame(18,26,462,247,GREY);
  // Q@MlP>
  if(msg1) {
    x = (479-(strlen(msg1)*5))/2;
    mh_print(x+1, 271-15, msg1, BLACK);
    mh_print(x, 271-16, msg1, WHITE);
  }
}

u8 GREY32[32] = {
  0x00, 0x10, 0x20, 0x30, 0x40, 0x50, 0x60, 0x70,
  0x80, 0x90, 0xa0, 0xb0, 0xc0, 0xd0, 0xe0, 0xf0,
  0xf0, 0xe0, 0xd0, 0xc0, 0xb0, 0xa0, 0x90, 0x80,
  0x70, 0x60, 0x30, 0x40, 0x30, 0x20, 0x10, 0x00,
};

int MessageBox(const char *msg, int type){
  int f=0, c;
  int MsgSel = 0;
  while(!bQuit) {
    pgFadevram(75, _menubmp);
    readpad();

    if(new_pad & (CTRL_LEFT | CTRL_RIGHT)) MsgSel = !MsgSel;
    if(new_pad & (CTRL_CROSS | CTRL_CIRCLE)) { readpad(); return MsgSel; }
    if((new_pad & (CTRL_SQUARE | CTRL_TRIANGLE)) && type) { readpad(); return 0; }

    pgStipplevram(BLACK);
    
    mh_print(240-63, 271-15, " / ~ Enter   /  Back", BLACK);
    mh_print(240-64, 271-16, " / ~ Enter   /  Back", WHITE);

//    x = (479-(strlen(msg)*5))/2;
//    mh_print(x,97,msg, BLACK);
//    mh_print(x,96,msg, WHITE);

      f++;
      c = RGB(GREY32[f&0x1f],GREY32[f&0x1f],GREY32[f&0x1f]);

    if(type) {
      if(MsgSel) {
        pgFillBox(122, 122, 242, 146, c);
      } else {
        pgFillBox(248, 122, 368, 146, c);
      }

      mh_print(257, 129, "\tCancel", BLACK);
      mh_print(256, 128, "\tCancel", WHITE);
      mh_print(131, 129, "\tOk", BLACK);
      mh_print(130, 128, "\tOk", WHITE);
    } else {
      pgFillBox(204, 122, 276, 146, c);
      mh_print(209, 129, "\t Ok", BLACK);
      mh_print(208, 128, "\t Ok", WHITE);
    }

    mh_print(28,32,msg,WHITE);
    pgScreenFlipV();
  }
  readpad();
  return 0;
}

void PostProgressMessage(const char *msg, u16 curr, u16 max){
    u32 c=curr, m=max;

    pgBitBlt(0,0,480,272,1,_splashbmp);
    mh_print(4,34,msg,WHITE);

    if(m) {
     pgDrawFrame(242, 34, 478, 50, GREY);
     pgFillBox(244, 36, 244+(232*c)/m, 48, WHITE);
    }

    pgScreenFlipV();
}

char Keys[2][4][13][16] = { { {
 "A", "B", "C", "D", "E", "F", "G", "H", "7", "8", "9", "-", " Backspace"
}, {
 "I", "J", "K", "L", "M", "N", "O", "P", "4", "5", "6", "+", "   Delete"
}, {
 "Q", "R", "S", "T", "U", "V", "W", "X", "1", "2", "3", "/", "   Enter"
}, {
 "Y", "Z","   Space","",""," Shift","", "_", "0",".","=", "*", "   Abort"
}
 }, {
{
 "a", "b", "c", "d", "e", "f", "g", "h", ";", "{", "}", ":", " Backspace"
}, {
 "i", "j", "k", "l", "m", "n", "o", "p", "!", "[", "]", "%", "   Delete"
}, {
 "q", "r", "s", "t", "u", "v", "w", "x", "?", "(", ")", "@", "   Enter"
}, {
 "y", "z","   Space","",""," Shift","", "\\", ",", "<" ,">", "$", "   Abort"
} } };

u8 KeyCodes[2][4][13] = { { {
 'A', 'B', 'C', 'D', 'E', 'F', 'G', 'H', '7', '8', '9', '-', 8
}, {
 'I', 'J', 'K', 'L', 'M', 'N', 'O', 'P', '4', '5', '6', '+', 127
}, {
 'Q', 'R', 'S', 'T', 'U', 'V', 'W', 'X', '1', '2', '3', '/', 13
}, {
 'Y', 'Z', ' ',   0,   0, 254,   0, '_', '0', '.', '=', '*', 255
} }, { {
 'a', 'b', 'c', 'd', 'e', 'f', 'g', 'h', ';', '{', '}', ':', 8
}, {
 'i', 'j', 'k', 'l', 'm', 'n', 'o', 'p', '!', '[', ']', '%', 127
}, {
 'q', 'r', 's', 't', 'u', 'v', 'w', 'x', '?', '(', ')', '@', 13
}, {
 'y', 'z', ' ',   0,   0, 254,   0,'\\', ',', '<', '>', '$' , 255
} } };

int VKB_InputText(char *Banner, char *outbuffer, int len) {
  int x, y, d=-1, f=0;
  int VKB_x = 0, VKB_y = 0, VKB_s = 0;
  int VKB_Done = 0, shift = 0;

  while(!VKB_Done && !bQuit) {
    f++;

    dlg_frame(Banner,"~ / F Select");
    pgPrint2(4,4,WHITE,outbuffer);
    pgPrint2(4+VKB_s,5,RED,"^");
    for(y=0; y<4; y++) {
      for(x=0; x<13; x++) {
        if(Keys[shift][y][x][0] != 0) {
          int c = WHITE, cx=BLACK;
          int fx = x*26+40;
          int fy = y*26+130;
          if(x>=8) fx+=16;
          if(x>=12) fx+=16;
          if((VKB_x==x) && (VKB_y==y)) {
            c = RED;
            cx = RGB(GREY32[f&0x1f]/2,GREY32[f&0x1f]/2,GREY32[f&0x1f]/2);
          }

          if(Keys[shift][y][x][1]) {
            pgFillBox(fx+1, fy+1, fx+70, fy+18, cx);
            pgDrawFrame(fx, fy, fx+71, fy+19, c&GREY);
            pgDrawFrame(fx+1, fy+1, fx+67, fy+15, c);
          } else {
            pgFillBox(fx, fy, fx+18, fy+18, cx);
            pgDrawFrame(fx, fy, fx+19, fy+19, c&GREY);
            pgDrawFrame(fx+1, fy+1, fx+15, fy+15, c);
          }

          if((x>=11) && (y!=1)) fx+=2;

          mh_print(fx+6, fy+4, Keys[shift][y][x], c);
        } else {
          if((VKB_x==x) && (VKB_y==y)) VKB_x++;
        }
      }
    }

    pgScreenFlipV();
    readpad();

    if(new_pad & CTRL_DOWN) { d=-1; VKB_y++; }
    if(new_pad & CTRL_UP) { d=-1; VKB_y--; }
    if(new_pad & CTRL_LEFT) { d=-1; VKB_x--; }
    if(new_pad & CTRL_RIGHT) { d=1; VKB_x++; }

    if(new_pad & CTRL_LTRIGGER) VKB_s--;
    if(new_pad & CTRL_RTRIGGER) VKB_s++;

    if(VKB_s<0) VKB_s=0;
    if(VKB_s>strlen(outbuffer)) VKB_s=strlen(outbuffer);

    if(VKB_x<0) VKB_x=12;
    if(VKB_y<0) VKB_y=3;
    if(VKB_x>=13) VKB_x=0;
    if(VKB_y>=4) VKB_y=0;

    while(!KeyCodes[shift][VKB_y][VKB_x]) {
      VKB_x+=d;
      if(VKB_x<0) VKB_x=12;
      if(VKB_x>=13) VKB_x=0;
    }

    if(new_pad & (CTRL_CIRCLE | CTRL_CROSS)) {
      if(!Keys[shift][VKB_y][VKB_x][1]) {
          if(KeyCodes[shift][VKB_y][VKB_x]) {
            outbuffer[VKB_s] = KeyCodes[shift][VKB_y][VKB_x];
            VKB_s++;
          }
      } else {
        switch(KeyCodes[shift][VKB_y][VKB_x]) {
         case 13:
          VKB_Done=2;
          break;
         case 255:
          VKB_Done=1;
          break;
         case 8:
          if(VKB_s) {
            strcpy(outbuffer + VKB_s-1, outbuffer + VKB_s);
            VKB_s--;
          }
          break;
         case 127:
          if(strlen(outbuffer)) {
            strcpy(outbuffer + VKB_s, outbuffer + VKB_s+1);
          }
          break;
         case 254:
          shift=!shift;
          break;
         default:
          if(KeyCodes[shift][VKB_y][VKB_x]) {
            outbuffer[VKB_s] = KeyCodes[shift][VKB_y][VKB_x];
            VKB_s++;
          }
          break;
        }
      }
    }
    if(new_pad & CTRL_SQUARE) {
      if(VKB_s && VKB_s < len) {
        strcpy(outbuffer + VKB_s-1, outbuffer + VKB_s);
        VKB_s--;
      }
    };

  }

  return (VKB_Done==2);
}

int VKB_Overlay(int px, int py, int *Vx, int *Vy, int *Vs, int *Vd) {
  int x, y, d=Vd;
  int VKB_x = *Vx, VKB_y = *Vy, shift = *Vs;

  if(d==0) d=-1;

  for(y=0; y<4; y++) {
    for(x=0; x<13; x++) {
      if(Keys[shift][y][x][0] != 0) {
        int c = WHITE, cx=BLACK;
        int fx = x*26+px;
        int fy = y*25+py;
        if(x>=8) fx+=16;
        if(x>=12) fx+=16;
        if((VKB_x==x) && (VKB_y==y)) {
          c = RED;
          cx = RGB(64,32,32);
        }

        if(Keys[shift][y][x][1]) {
          pgFillBox(fx+1, fy+1, fx+70, fy+18, cx);
          pgDrawFrame(fx, fy, fx+71, fy+19, c&GREY);
          pgDrawFrame(fx+1, fy+1, fx+67, fy+15, c);
        } else {
          pgFillBox(fx, fy, fx+18, fy+18, cx);
          pgDrawFrame(fx, fy, fx+19, fy+19, c&GREY);
          pgDrawFrame(fx+1, fy+1, fx+15, fy+15, c);
        }

        if((x>=11) && (y!=1)) fx+=2;

        mh_print(fx+6, fy+4, Keys[shift][y][x], c);
      } else {
        if((VKB_x==x) && (VKB_y==y)) VKB_x++;
      }
    }
  }

  if(new_pad & CTRL_DOWN) { d=-1; VKB_y++; }
  if(new_pad & CTRL_UP) { d=-1; VKB_y--; }
  if(new_pad & CTRL_LEFT) { d=-1; VKB_x--; }
  if(new_pad & CTRL_RIGHT) { d=1; VKB_x++; }

  if(VKB_x<0) VKB_x=12;
  if(VKB_y<0) VKB_y=3;
  if(VKB_x>=13) VKB_x=0;
  if(VKB_y>=4) VKB_y=0;

  while(!KeyCodes[shift][VKB_y][VKB_x]) {
    VKB_x+=d;
    if(VKB_x<0) VKB_x=12;
    if(VKB_x>=13) VKB_x=0;
  }

  if(new_pad & (CTRL_CIRCLE | CTRL_CROSS)) {
    switch(KeyCodes[shift][VKB_y][VKB_x]) {
      case 254:
        *Vs = !shift;
        return 0;
      default:
        if(KeyCodes[shift][VKB_y][VKB_x])
          return KeyCodes[shift][VKB_y][VKB_x];
    }
  }

  *Vx = VKB_x;
  *Vy = VKB_y;
  *Vd = d;
  return 0;
}

int MsgPrintf(int type, char *fmt, ...) {
  va_list opt;
  
  char buff[2048];
  int bufsz;
  
  va_start(opt, fmt);
  bufsz = vsnprintf( buff, (size_t) sizeof(buff), fmt, opt);
  buff[bufsz] = 0;

  if(type==2) { 
    PostProgressMessage(buff, 0, 0);
    return 0;
  } else
    return MessageBox(buff, type);
}
