#include <pspkernel.h>
#include <pspiofilemgr_fcntl.h>
#include <pspiofilemgr_dirent.h>
#include "vncdbg.h"
#include "pg.h"
#include "filer.h"
#include "dialog.h"
#include <string.h>
#include <stdio.h>
#include "libvnc/vnc.h"


extern int bQuit;
extern char VNCPath[MAXPATH];
char hostpath[MAXPATH];

#define ICONLIST

#ifdef ICONLIST
#define ICONSIZE (64*64*2)
extern u16 _newicon[ICONSIZE/2];
extern u16 _unkicon[ICONSIZE/2];
extern u16 _xbxicon[ICONSIZE/2];
extern u16 _tuxicon[ICONSIZE/2];
extern u16 _macicon[ICONSIZE/2];
extern u16 _winicon[ICONSIZE/2];
int pickicon=0;

typedef struct {
  u32 host;
  u16 port;
  char name[MAXNAME];
  u16 icon[ICONSIZE/2];
} hostent;

#define MAXICON 16
hostent Icon[MAXICON+1];

int HostCount=0;
#endif

#define UPPER_THRESHOLD  0xcf
#define LOWER_THRESHOLD  0x2f

char hostfn[32] = "";
u32 IP_h = 0xc0a80001;
u16 IP_p = 5900;
s8 IP_s = 0, IP_Done;

extern u16 FilerColor[4];

void UnpackPortDigits(char *d, int x) {
  x &= 0xffff;
  d[0] = '0'+ (x/10000);
  d[1] = '0'+ ((x/1000)%10);
  d[2] = '0'+ ((x/100)%10);
  d[3] = '0'+ ((x/10)%10);
  d[4] = '0'+ (x%10);
  if(d[0] == '0') {
    d[0]=' ';
    if(d[1] == '0') {
      d[1]=' ';
      if(d[2] == '0') {
        d[2]=' ';
        if(d[3] == '0') {
          d[3]=' ';
        }
      }
    }
  }
}

void UnpackHostDigits(char *d, u32 h) {
  int i, x;
  for(i=0; i<4; i++) {
    x = (h>>((3-i)*8)) & 0xff;
    d[i*4+0] = '0'+ (x/100);
    d[i*4+1] = '0'+ ((x/10)%10);
    d[i*4+2] = '0'+ (x%10);
    if(d[i*4+0] == '0') {
      d[i*4+0]=' ';
      if(d[i*4+1] == '0')
        d[i*4+1]=' ';
    }
  }
}

#ifndef ICONLIST
void LoadHost(char *path) {
  int fd;
  char temppath[MAXPATH];
 
  if(!path) return;
  
  if(strncmp("ms0:", path, 3)) {
    strcpy(temppath, VNCPath);
    strcat(temppath, path);
  } else
    strcpy(temppath, path);

//  MsgPs1("Loading:\n  ", temppath, "", 0);

  fd = sceIoOpen(temppath, PSP_O_RDONLY, 0777);
  IP_h = 0; IP_p = 0;
  sceIoRead(fd, &IP_h, 4);
  sceIoRead(fd, &IP_p, 2);
  sceIoClose(fd);
}
#else
void LoadHost(u8 index) {
  IP_h = Icon[index].host;
  IP_p = Icon[index].port;
  strcpy(hostfn, Icon[index].name);
}
void LoadHostFile(int x) {
  char fn[MAXPATH];
  strcpy(fn, VNCPath);
  strcat(fn, "Hosts/");
  strcat(fn, Icon[x].name);
  memcpy(Icon[x].icon, _unkicon, ICONSIZE);
  int fd = sceIoOpen(fn, PSP_O_RDONLY, 0777);
  if(fd) {
    sceIoRead(fd, &Icon[x], sizeof(hostent));
    sceIoClose(fd);
  }
}
void LoadHosts() {
  int fd, x;
  SceIoDirent de;
  char hostfiles[MAXPATH];
  
  strcpy(hostfiles, VNCPath);
  strcat(hostfiles, "Hosts");
  
  strcpy(Icon[0].name, "New Host");
  Icon[0].host = 0xc0a80001;
  Icon[0].port = 5900;
  memcpy(Icon[0].icon, _newicon, ICONSIZE);
  HostCount = 1;

  fd = sceIoDopen(hostfiles);
  if(fd) {
    while(HostCount < MAXICON) {
      memset(&de, 0x00, sizeof(SceIoDirent));
      if(sceIoDread(fd, &de)<=0) break;
      if(de.d_name[0] == '.') continue;
      if(!FIO_S_ISDIR(de.d_stat.st_attr)) {
        strcpy(Icon[HostCount].name, de.d_name);
        HostCount++;
      }
    }
    sceIoDclose(fd);
  }
  for(x=1; x<HostCount; x++) {
    LoadHostFile(x);
  }
}
#define SICONS 4
hostent StockIcon[SICONS];

void IconChooser() {
  int x, w, px, s = 0;
  int iconDone = 0;

  strcpy(StockIcon[0].name, "Mac Icon");
  memcpy(StockIcon[0].icon, _macicon, ICONSIZE);
  strcpy(StockIcon[1].name, "Win Icon");
  memcpy(StockIcon[1].icon, _winicon, ICONSIZE);
  strcpy(StockIcon[2].name, "Tux Icon");
  memcpy(StockIcon[2].icon, _tuxicon, ICONSIZE);
  strcpy(StockIcon[3].name, "Xbox Icon");
  memcpy(StockIcon[3].icon, _xbxicon, ICONSIZE);

  while(!iconDone && !bQuit) {
    dlg_frame("Pick Icon", " / ~ Enter");

    pgFillBox(208, 62, 272, 130, WHITE);

    for(px=0; px<3; px++) {
      bltrect ir;
      x = px + s - 1;
      if(x>=0 && x<SICONS) {
        w = strlen(StockIcon[x].name)*5;
        if(x==s) {
          mh_print(px*128+80-(w/2), 140, StockIcon[x].name, WHITE);
        } else {
          mh_print(px*128+80-(w/2), 140, StockIcon[x].name, GREY);
        }
        ir.x = ir.y = 0;
        ir.w = ir.h = 64;
        ir.s = 64;
        ir.b = StockIcon[x].icon;
        pgBitBltR(&ir, px*128+80, 64);
      }
    }

    pgScreenFlipV();

    readpad();

    if(new_pad & CTRL_RIGHT) s++;
    if(new_pad & CTRL_LEFT) s--;

    if(s<0) s=SICONS-1;
    if(s>=SICONS) s=0;

    if(new_pad & (CTRL_CIRCLE | CTRL_CROSS)) {
      pickicon = s;
      return;
    }
  }
}
#endif

void SaveHost(char *path) {
  int fd;
  char temppath[MAXPATH];
  
  if(!path) return;

  strcpy(temppath, VNCPath);
  strcat(temppath, "hosts/");
  strcat(temppath, path);
  
  fd = sceIoOpen(temppath, PSP_O_CREAT|PSP_O_RDWR|PSP_O_TRUNC, 0777);
  
  sceIoWrite(fd, &IP_h, 4);
  sceIoWrite(fd, &IP_p, 2);
#ifdef ICONLIST
  char name[MAXNAME];
  memset(name, 0, MAXNAME);
  strcpy(name, path);
  sceIoWrite(fd, name, MAXNAME);
  sceIoWrite(fd, (u8*)StockIcon[pickicon].icon, ICONSIZE);
#endif
  sceIoClose(fd);
}

void IP_Render(int s, int x, int y) {
    char HostText[] = "\t000.000.000.000:00000";

    UnpackHostDigits(HostText+1, IP_h);
    UnpackPortDigits(HostText+17, IP_p);

    if(s<12) { // convert packed to dotted
      int g = s / 3;
      int d = s % 3;
      s=g*4+d;
    } else {
      s+=4;
    }

    mh_print(x*16,y*16,HostText, GREY);
    mh_print((x+s)*16,(y+1)*16,"\t^", RED);
}

void IP_Minus(int s) {
  long b, g, d = 100;
  if(s<12) {
    g = s / 3;
    s %= 3;
    while(s) { d/=10; s--; }
  
    b = (IP_h>>((3-g)*8))&0xff;
    IP_h &= ~(0xff<<((3-g)*8));
    if (b-d>=0) b-=d;
    else b=0;
    IP_h |= b<<((3-g)*8);
  } else {
    s -= 12;    
    d = 10000;
    while(s) { d/=10; s--; }
  
    if (IP_p-d>=0) IP_p-=d;
    else IP_p = 0;
  }
}

void IP_Plus(int s) {
  long b, g, d = 100;
  if(s<12) {
    g = s / 3;
    s %= 3;
    while(s) { d/=10; s--; }
  
    b = (IP_h>>((3-g)*8))&0xff;
    IP_h &= ~(0xff<<((3-g)*8));
    if (b+d<=0xff) b+=d;
    else b = 0xff;
    IP_h |= b<<((3-g)*8);
  } else {
    s -= 12;    
    d = 10000;
    while(s) { d/=10; s--; }
  
    if (IP_p-d<=0xffff) IP_p+=d;
    else IP_p = 0xffff;
  }
}

void IP_ParseInput() {
  readpad();

  if(new_pad & CTRL_DOWN) IP_Minus(IP_s);
  if(new_pad & CTRL_UP) IP_Plus(IP_s);
  if(new_pad & CTRL_LEFT) IP_s--;
  if(new_pad & CTRL_RIGHT) IP_s++;

  if(IP_s<0) IP_s=0;
  if(IP_s>16) IP_s=16;

  if(new_pad & (CTRL_CIRCLE | CTRL_CROSS)) { IP_Done=2; };
  if(new_pad & CTRL_SQUARE) { IP_Done=1; };

}

void IP_Menu() {
  IP_Done = 0;
  IP_s = 0;

  while(!IP_Done && !bQuit) {
    dlg_frame("\tHost:","~ / F Save       [] Cancel");
    IP_Render(IP_s,4,8);

    pgScreenFlipV();
    IP_ParseInput();
  }

  if(IP_Done==2) {
    if(!VKB_InputText("\tFilename?", hostfn, 32)) return;
#ifdef ICONLIST
    IconChooser();
#endif
    SaveHost(hostfn);
#ifndef ICONLIST
  } else {
    LoadHost(hostfn);
#endif
  }
}

char MenuText[5][16] = {
  "\tNew Host",
  "\tLoad Host File",
  "\tEdit Host File",
  "\tConnect",
  "\tExit"
};

int MainMenu_s = 1;

#ifndef ICONLIST
void vncMenu() {
  int y;
  int vncDone = 0;

  while(!vncDone && !bQuit) {
    char HostText[] = "\t000.000.000.000:00000";

    dlg_frame(hostpath, " / ~ Enter");

    for(y=0; y<=4; y++) {
      if(y==MainMenu_s) {
        mh_print(48, y*20+48, MenuText[y], WHITE);
        mh_print(34, y*20+50, ">", WHITE);
      } else {
        mh_print(48, y*20+48, MenuText[y], GREY);
      }
    }

    UnpackHostDigits(HostText+1, IP_h);
    UnpackPortDigits(HostText+17, IP_p);

    mh_print(48, 200, HostText, WHITE);

    pgScreenFlipV();

    readpad();

    if(new_pad & CTRL_DOWN) MainMenu_s++;
    if(new_pad & CTRL_UP) MainMenu_s--;

    if(MainMenu_s<0) MainMenu_s=3;
    if(MainMenu_s>4) MainMenu_s=0;

    if(new_pad & (CTRL_CIRCLE | CTRL_CROSS)) {
      switch(MainMenu_s) {
        case 0: {
          strcpy(hostfn, "NewHost");
          IP_Menu();
          strcpy(hostpath, VNCPath);
          strcat(hostpath, "Hosts/");
          strcat(hostpath, hostfn);
          break;
        }
        case 1: {
          if(getFilePath(hostpath))
            LoadHost(hostpath);
          break;
        }
        case 2: {
          if(hostpath[0]) {
            char *hp = strrchr(hostpath, '/');
            if(hp)
              strcpy(hostfn, hp+1);
            else
              strcpy(hostfn, hostpath);
            IP_Menu();
          }
          break;
        }
        case 3: {
          DB_ServerConnection srv;
          if(!hostfn) break;

          memset(&srv, 0, sizeof(DB_ServerConnection));
          srv.address = IP_h;
          srv.port = IP_p;
          srv.scaleFactor = 1;
          strncpy(srv.name, hostfn, 32);

          vncMain(&srv);
          break;
        }
        case 4: PostProgressMessage("\tExiting PSP VNC\t", 0, 4); return;
      }
    }
  }
}
#else
void vncMenu() {
  int x, w, px, s = 0;
  int vncDone = 0;

  LoadHosts();

  while(!vncDone && !bQuit && Icon) {
    char msg[MAXPATH+16];
    sprintf(msg, "%i Hosts : ", HostCount);
    strcat(msg, VNCPath);
    strcat(msg, "Hosts");

    dlg_frame(msg, " / ~ Enter   Delete");

    pgFillBox(240-34, 62, 240+33, 129, WHITE);

    for(px=0; px<3; px++) {
      bltrect ir;
      x = px + s - 1;
      if(x>=0 && x<HostCount) {
        int wh;
        char hostport[64];
        sprintf(hostport, "%i.%i.%i.%i:%i", (Icon[x].host>>24)&0xff, (Icon[x].host>>16)&0xff, (Icon[x].host>>8)&0xff, Icon[x].host&0xff, Icon[x].port);
        w = strlen(Icon[x].name);
        wh = strlen(hostport);
        if(x==s) {
          mh_print(px*128+80-(w/2), 140, Icon[x].name, WHITE);
          mh_print(px*128+80-(wh/2), 148, hostport, WHITE);
        } else {
          mh_print(px*128+80-(w/2), 140, Icon[x].name, GREY);
          mh_print(px*128+80-(wh/2), 148, hostport, GREY);
        }
        ir.x = ir.y = 0;
        ir.w = ir.h = 64;
        ir.s = 64;
        ir.b = Icon[x].icon;
        pgBitBltR(&ir, px*128+80, 64);
      }
    }

    pgScreenFlipV();

    readpad();

    if(new_pad & CTRL_RIGHT) s++;
    if(new_pad & CTRL_LEFT) s--;

    if(s<0) s=HostCount-1;
    if(s>=HostCount) s=0;

    if((new_pad & CTRL_TRIANGLE) && s) {
      int y = MsgPrintf(1, "Are you sure you wish to delete '%s'?", Icon[s].name);
      if(y) {
        char hostfile[MAXPATH];
        strcpy(hostfile, VNCPath);
        strcat(hostfile, "Hosts/");
        strcat(hostfile, Icon[s].name);
        sceIoRemove(hostfile);
      }
      LoadHosts();
    }

    if(new_pad & (CTRL_CIRCLE | CTRL_CROSS)) {
      if(!strcmp(Icon[s].name, "New Host")) {
        strcpy(hostfn, "Untitled Host");
        IP_Menu();
        LoadHosts();
      } else {
        DB_ServerConnection srv;

        memset(&srv, 0, sizeof(DB_ServerConnection));
        srv.address = Icon[s].host;
        srv.port = Icon[s].port;
        srv.scaleFactor = 1;
        strncpy(srv.name, hostfn, 32);

        vncMain(&srv);
      }
    }
  }
}
#endif
